using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserRole;
namespace CMSMicroservice.Protobuf.Validator.UserRole;

public class GetAllUserRoleByFilterRequestValidator : AbstractValidator<GetAllUserRoleByFilterRequest>
{
    public GetAllUserRoleByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllUserRoleByFilterRequest>.CreateWithOptions((GetAllUserRoleByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
